<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Серверная сторона AJAX настройки блока "Магазин Lite: Фильтры".
 *
 * <a href="http://wiki.a-cms.ru/blocks/shoplite_filters">Руководство</a>.
 */

class shoplite_filters_BlockRequest extends A_Request
{
/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
    { case "add": $this->Add(); break;
	  case "edit": $this->Edit(); break;
	}
  }

/**
 * Обработчик действия: Отдает форму добавления.
 */

  function Add()
  {
	$form = new A_Form("block_shoplite_filters_add.tpl");
	$form->data['sections']=A::$DB->getAssoc("SELECT id,caption FROM ".DOMAIN."_sections WHERE module='shoplite'");
	$form->data['fields']=array();
	if(!empty($form->data['sections']))
	{ $section=getSectionbyId(key($form->data['sections']));
	  $checkeds=array('name','idcat','price');
	  $fields=array('name'=>'Название','idcat'=>'Категория','price'=>'Цена','favorite'=>'Спецпредложение','new'=>'Новинка');
	  $fields=array_merge($fields,getFields($section));
	  $i=1;
	  foreach($fields as $field=>$caption)
	  $form->data['fields'][]=array('field'=>$field,'caption'=>$caption,'checked'=>in_array($field,$checkeds),'sort'=>$i++);
	}
	$this->RESULT['html']=$form->getContent();
  }

/**
 * Обработчик действия: Отдает форму редактирования.
 */

  function Edit()
  {
	$form = new A_Form("block_shoplite_filters_edit.tpl");
	$block=A::$DB->getRowById($_POST['id'],DOMAIN."_blocks");
	$form->data=!empty($block['params'])?unserialize($block['params']):array();
	$form->data['sections']=A::$DB->getAssoc("SELECT id,caption FROM ".DOMAIN."_sections WHERE module='shoplite'");
	$form->data['fields']=array();
	if($section=getSectionById($form->data['idsec']))
	{ $filters=!empty($form->data['filters'])?$form->data['filters']:array();
	  $maxsort=0;
	  foreach($filters as $field=>$data)
	  if(!empty($data['sort']) && $data['sort']>$maxsort)
	  $maxsort=$data['sort'];
	  $fields=array('name'=>'Название','idcat'=>'Категория','price'=>'Цена','favorite'=>'Спецпредложение','new'=>'Новинка');
	  $fields=array_merge($fields,getFields($section));
	  foreach($fields as $field=>$caption)
	  $form->data['fields'][]=array(
	  'field'=>$field,
	  'caption'=>!empty($filters[$field]['caption'])? $filters[$field]['caption']:$caption,
	  'sort'=>(integer)(isset($filters[$field]['sort'])?$filters[$field]['sort']:++$maxsort),
	  'checked'=>isset($filters[$field]['checked'])?$filters[$field]['checked']:false);
	}
	$form->data['fields']=array_multisort_key($form->data['fields'],'sort');
	$this->RESULT['html']=$form->getContent();
  }
}

A::$REQUEST = new shoplite_filters_BlockRequest;